/*
 * #%L
 * EUGene :: EUGene
 * 
 * $Id: ModelReader.java 863 2010-04-15 14:22:49Z tchemit $
 * $HeadURL: http://svn.nuiton.org/svn/eugene/tags/eugene-2.0.1/eugene/src/main/java/org/nuiton/eugene/ModelReader.java $
 * %%
 * Copyright (C) 2004 - 2010 CodeLutin
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as 
 * published by the Free Software Foundation, either version 3 of the 
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Lesser Public License for more details.
 * 
 * You should have received a copy of the GNU General Lesser Public 
 * License along with this program.  If not, see
 * <http://www.gnu.org/licenses/lgpl-3.0.html>.
 * #L%
 */

package org.nuiton.eugene;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.nuiton.eugene.models.Model;

import java.io.File;

/**
 * FileReader TODO real doc :)
 *
 * Created: 26 oct. 2009
 *
 * @param <M> Model to create from reading input files
 * @author fdesbois
 * @version $Revision: 863 $
 *
 * Mise a jour: $Date: 2010-04-15 16:22:49 +0200 (jeu., 15 avril 2010) $
 * par : */
public abstract class ModelReader<M extends Model> {

    private static final Log log = LogFactory.getLog(ModelReader.class);

    /** date de derniere modification de la source la plus recente */
    protected long lastModifiedSource = 0;

    protected void setLastModifiedSource(File[] files) {
        for (File file : files) {
            if (file.lastModified() > getLastModifiedSource()) {
                lastModifiedSource = file.lastModified();
                log.debug("source date: " + lastModifiedSource
                        + " files[i] date: " + file.lastModified() + "(" + file
                        + ")");
            }
        }
    }

    public long getLastModifiedSource() {
        return lastModifiedSource;
    }

    //TODO-TC : il vaut mieux directement un type dit variable
    // example : public abstract M read(File... file) {}

    public M read(File file) {
        return read(new File[] { file });
    }

    public abstract M read(File[] file);

}
